//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header:  $


#include "fsyspriv.h"





// RETURN FILE HANDLE NUMBER, GIVEN FS_FILE * POINTER

int FSGetHandle(FS_FILE *file)
{
FS_VOLUME *fs;
int f;

if(!FSystem.Init) return FS_INVHANDLE;

if(file==NULL) return FS_INVHANDLE;

if(file->Volume&(~3)) return FS_INVHANDLE;		// INVALID VOLUME --> FILE STRUCTURE CORRUPT

fs=FSystem.Volumes[file->Volume];

if(fs==NULL) return FS_INVHANDLE;

for(f=0;f<FS_MAXOPENFILES;++f)
{
if(fs->Files[f]==file) return 3+f; 

}

return FS_INVHANDLE;
}


int FSGetFileFromHandle(int handle,FS_FILE **file)
{
int k=handle-3;
if(k<0) return FS_INVHANDLE;
FS_VOLUME *fs=FSystem.Volumes[FSystem.CurrentVolume];

if(fs==NULL) return FS_INVHANDLE;

FS_FILE *f=fs->Files[k];
if(f==NULL) return FS_INVHANDLE;

*file=f;
return FS_OK;

}


