//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}
#include "gstring.h"
#include "gui.h"

gString::gString() : MemBlock()
{
}

gString::~gString()
{
}

int gString::TextWidth(int Offset,int EndOffset,gFont& f)
{
	char *chrptr;
	int limit;
	int totalwidth=0;
	if(Offset<0) return -1;
	if(Offset>=TotalUsed) return -1;
	do {
		limit=GetUpperLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset<=limit) {
		if(Offset==EndOffset || *chrptr==0 || *chrptr=='\n' || *chrptr=='\r') return totalwidth;
		totalwidth+=f.CharWidth(*chrptr);
		++chrptr;
		++Offset;
	}
	} while(IsValidOffset(Offset));
	
	return totalwidth;
}




int gString::PrevLine(int Offset)
{
	char *chrptr;
	int limit,flag=0;
	if(Offset<=0) return -1;
	if(Offset>=TotalUsed) return -1;
	Offset--;
	do {
		limit=GetLowerLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset>=limit) {
		if(*chrptr=='\n') {
			if(flag) { return Offset+1; }
			flag=1;		// 1=NEWLINE FOUND, THERE COULD BE \r BEFORE
		}
		else {
		if(*chrptr=='\r') { if(flag==2) return Offset+1; else flag=2; }
		else { if(flag==1) flag=2; }
		}
		--Offset;
		--chrptr;
	}
	} while(IsValidOffset(Offset));
	
	if(!flag) return -1;
	return 0;
	
}
int gString::NextLine(int Offset)
{
	char *chrptr;
	int limit,flag=0;
	if(Offset<0) return -1;
	if(Offset>=TotalUsed) return -1;
	do {
		limit=GetUpperLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset<=limit) {
		if(*chrptr=='\r') {
			if(flag) { return Offset; }
			flag=1;		// 1=NEWLINE FOUND, THERE COULD BE \n AFTER
		}
		else {
		if(*chrptr==0) return -1;
		if(*chrptr=='\n') return Offset+1;
		else { if(flag==1) return Offset; }
		}
		++Offset;
		++chrptr;
	}
	} while(IsValidOffset(Offset));
	
	if(!flag) return -1;
	return 0;
	
	
}










int gString::EndOfPrevLine(int Offset)
{
	char *chrptr;
	int limit,flag=0;
	if(Offset<=0) return -1;
	if(Offset>=TotalUsed) return -1;
	Offset--;
	do {
		limit=GetLowerLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset>=limit) {
		if(*chrptr=='\n') {
			if(flag) { return Offset+1; }
			flag=1;		// 1=NEWLINE FOUND, THERE COULD BE \r BEFORE
		}
		else {
		if(*chrptr=='\r') return Offset;
		else { if(flag==1) return Offset+1; }
		}
		--Offset;
		--chrptr;
	}
	} while(IsValidOffset(Offset));
	
	if(!flag) return -1;
	return 0;
	
}

void gString::InsertChar(int Offset,char a)
{
char temp=a;
Insert(Offset,1,&temp);
}

void gString::Delete(int offset)
{
	MemBlock::Delete(offset,1);
}


int gString::StartOfLine(int Offset)	// RETURN OFFSET OF START OF CURRENT LINE
{
	char *chrptr;
	int limit,flag=0;
	if(Offset<0) return -1;
	if(Offset>=TotalUsed) return -1;

	do {
		limit=GetLowerLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset>=limit) {
		if(*chrptr=='\n' && flag) return Offset+1;
		else {
		if(*chrptr=='\r' && flag) return Offset+1;
		else {
			if(!flag) flag=1;
		}
		}
		--Offset;
		--chrptr;
	}
	} while(IsValidOffset(Offset));
	
	return 0;
}


int gString::EndOfLine(int Offset) // RETURN OFFSET TO THE END OF CURRENT LINE
{
	char *chrptr;
	int limit;
	if(Offset<0) return -1;
	if(Offset>=TotalUsed) return -1;
	do {
		limit=GetUpperLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset<=limit) {
		if(*chrptr=='\r') return Offset;
		if(*chrptr=='\n') return Offset;
		if(*chrptr==0) return Offset;
		++Offset;
		++chrptr;
	}
	} while(IsValidOffset(Offset));
	
	return -1;
	
}

int gString::NumLines()
{
	int Offset=0;
	int NumLines=1;
	char *chrptr;
	int limit,flag=0;
	do {
		limit=GetUpperLimit(Offset);
		chrptr=GetPtr(Offset);

		while(Offset<=limit) {
		if(*chrptr=='\r') {
			++NumLines;
			flag=1;		// 1=NEWLINE FOUND, THERE COULD BE \n AFTER
		}
		else {
		if(*chrptr==0) return NumLines;
		if(*chrptr=='\n') { if(!flag) ++NumLines;}
		flag=0;
		}
		++Offset;
		++chrptr;
	}
	} while(Offset<TotalUsed);
	
	return NumLines;
	
}
