//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_draw_line_on(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();
    if(g==NULL) g=HPG_STDSCREEN;
    if (y1 == y2)
    {
        int sx, len;
        if (x1 > x2)
        {
            sx = x2;
            len = x1 - x2 + 1;
        }
        else
        {
            sx = x1;
            len = x2 - x1 + 1;
        }

        _hpg_draw(g, sx, y1, len, -1, -1);
    }
    else
    {
        int dx, dy;
        int numpixels;
        int dinc1, dinc2, xinc1, xinc2, yinc1, yinc2;

        int x, y, d;
        int px, py, sx;

        int i;

        dx = (x1 > x2) ? (x1 - x2) : (x2 - x1);
        dy = (y1 > y2) ? (y1 - y2) : (y2 - y1);

        if (dx > dy)
        {
            numpixels = dx + 1;
            d = (2 * dy) - dx;
            dinc1 = 2 * dy;
            dinc2 = (dy - dx) * 2;
            xinc1 = 1;
            xinc2 = 1;
            yinc1 = 0;
            yinc2 = 1;
        }
        else
        {
            numpixels = dy + 1;
            d = (2 * dx) - dy;
            dinc1 = 2 * dx;
            dinc2 = (dx - dy) * 2;
            xinc1 = 0;
            xinc2 = 1;
            yinc1 = 1;
            yinc2 = 1;
        }

        if (x1 > x2)
        {
            xinc1 = -xinc1;
            xinc2 = -xinc2;
        }

        if (y1 > y2)
        {
            yinc1 = -yinc1;
            yinc2 = -yinc2;
        }

        x = x1;
        y = y1;

        sx = x;

        for (i = 0; i < numpixels; i++)
        {
            px = x;
            py = y;

            if (d < 0)
            {
                d += dinc1;
                x += xinc1;
                y += yinc1;
            }
            else
            {
                d += dinc2;
                x += xinc2;
                y += yinc2;
            }

            if (y != py)
            {
                if (xinc2 < 0) _hpg_draw(g, px, py, sx - px + 1, -1, -1);
                else _hpg_draw(g, sx, py, px - sx + 1, -1, -1);
                sx = x;
            }
        }

        if (x != sx)
        {
            if (xinc2 < 0) _hpg_draw(g, x + 1, y, sx - x, -1, -1);
            else _hpg_draw(g, sx, y, x - sx, -1, -1);
        }
    }
}
