//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_free.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>

extern int __sat3_getblockinfo(SAT_OBJECT ptr,SAT_OBJECT *blkstart,int *blksize);


int __sat3_ptrisref(SAT_OBJECT ptr)
{
if((ptr&0x60000000)!=0) return INVALID_PTR;

SAT_OBJECT blk,blkend;
int blksize;

if(__sat3_getblockinfo(ptr,&blk,&blksize)==INVALID_PTR) return INVALID_PTR;

blkend=blk+blksize;

SAT_OBJECT tmpptr;
SAT_OBJECT chkptr;
int count;

// CHECK FOR POINTERS IN DATA STACK

tmpptr=sat3_peek(SAT_DSKTOP,5);
while((chkptr=sat3_peek(tmpptr,5))) {
if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;	
tmpptr+=5;
}

// CHECK FOR POINTERS IN RETURN STACK

tmpptr=sat3_peek(SAT_RSKTOP,5)-5;
while( (chkptr=sat3_peek(tmpptr,5))& (~0xf)) {
if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;	
tmpptr-=5;
}

// CHECK FOR SYSTEM VARIABLES

tmpptr=(SAT_OBJECT) SAT_INTRPPTR;

for(count=0x16e;count>=0;--count,tmpptr+=5)
{
chkptr=sat3_peek(tmpptr,5);
if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;
}

// CHECK FOR TEMPORARY ENVIRONMENTS

tmpptr=sat3_peek(SAT_TEMPENV,5);


do {
	
count=sat3_peek(tmpptr,5);

tmpptr+=10;

if(count>15) {
	count-=15;
	
	do {
	chkptr=sat3_peek(tmpptr,5);
	tmpptr+=5;
	if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;
	chkptr=sat3_peek(tmpptr,5);
	tmpptr+=5;
	if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;
	count-=10;
	}
	while(count>0);
	
	count=1;	// ENSURE LOOP IS REPEATED
	continue; 
}
	
} while(count>0);


// CHECK FOR PTRS IN THE TOUCHTAB TABLE


tmpptr=sat3_peek(SAT_TOUCHTAB,5)+3;

while( (chkptr=sat3_peek(tmpptr,5))) {
if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;	
tmpptr+=5;
}

// CHECK FOR PTRS IN THE FSTVGERPTR TABLE


tmpptr=sat3_peek(SAT_FSTVGERPTR,5);


if(tmpptr) {
	// CHECK FOR THE FSTVGERPTR ITSELF
	if(tmpptr>=blk && tmpptr<blkend) return BLOCK_REF;	
	
	tmpptr+=15;
	count=sat3_peek(tmpptr,5);
	while(count--) {
		tmpptr+=20;
		while( (chkptr=sat3_peek(tmpptr,5))) {
			if(chkptr>=blk && chkptr<blkend) return BLOCK_REF;	
			tmpptr+=5;
		}
	}
	

}

// BLOCK IS NOT REFERENCED

return BLOCK_UNREF;
}

















// FIX TEMPOB POINTERS FOR GC
// ALL PTRS >=startptr AND <endptr WILL BE UPDATED +offset

void __sat3_fixptrs(SAT_OBJECT startptr,SAT_OBJECT endptr,SAT_OBJECT offset)
{
if((startptr&0x60000000)!=0) return;
if((endptr&0x60000000)!=0) return;

SAT_OBJECT tmpptr;
SAT_OBJECT chkptr;
int count;

// CHECK FOR POINTERS IN DATA STACK

tmpptr=sat3_peek(SAT_DSKTOP,5);
while((chkptr=sat3_peek(tmpptr,5))) {
if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
tmpptr+=5;
}

// CHECK FOR POINTERS IN RETURN STACK

tmpptr=sat3_peek(SAT_RSKTOP,5)-5;
while( (chkptr=sat3_peek(tmpptr,5))& (~0xf)) {
if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
tmpptr-=5;
}


// CHECK FOR TEMPORARY ENVIRONMENTS

tmpptr=sat3_peek(SAT_TEMPENV,5);


do {
	
count=sat3_peek(tmpptr,5);

tmpptr+=10;

if(count>15) {
	count-=15;
	
	do {
	chkptr=sat3_peek(tmpptr,5);
	if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
	tmpptr+=5;
	chkptr=sat3_peek(tmpptr,5);
	if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
	tmpptr+=5;
	count-=10;
	}
	while(count>0);
	
	count=1;	// ENSURE LOOP IS REPEATED
	continue; 
}
	
} while(count>0);


// CHECK FOR PTRS IN THE TOUCHTAB TABLE


tmpptr=sat3_peek(SAT_TOUCHTAB,5)+3;

while( (chkptr=sat3_peek(tmpptr,5))) {
if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
tmpptr+=5;
}

// CHECK FOR PTRS IN THE FSTVGERPTR TABLE


tmpptr=sat3_peek(SAT_FSTVGERPTR,5);


if(tmpptr) {
	// CHECK FOR THE FSTVGERPTR ITSELF
	if(tmpptr>=startptr && tmpptr<endptr) sat3_poke(tmpptr,tmpptr+offset,5);	
	
	tmpptr+=15;
	count=sat3_peek(tmpptr,5);
	while(count--) {
		tmpptr+=20;
		while( (chkptr=sat3_peek(tmpptr,5))) {
			if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
			tmpptr+=5;
		}
	}
	

}


// CHECK FOR SYSTEM VARIABLES

tmpptr=(SAT_OBJECT) SAT_INTRPPTR;

for(count=0x16e;count>=0;--count,tmpptr+=5)
{
chkptr=sat3_peek(tmpptr,5);
if(chkptr>=startptr && chkptr<endptr) sat3_poke(tmpptr,chkptr+offset,5);	
}

// ALL REFERENCES UPDATED

return;
}


// PUBLIC API: free AN OBJECT ONLY IF IT'S THE MAIN OBJECT
// RETURNS INVALID_PTR, BLOCK_USED (WHEN PTR IS NOT MAIN OBJECT) or BLOCK_FREE IF SUCEEDED


int sat3_free(SAT_OBJECT obj)
{
SAT_OBJECT blk;
int blksize;

if(__sat3_getblockinfo(obj,&blk,&blksize)==INVALID_PTR) return INVALID_PTR;

if(obj!=blk) return BLOCK_USED; 

if((obj&0x60000000)!=0) {
	// C-HEAP free
	char *p=(char *)((obj>>1)&(~0xf0000000));
	free(p);
	return BLOCK_FREE;
}
	
// DO A SATURN FREE	
	
if(__sat3_ptrisref(obj)!=BLOCK_UNREF) { return BLOCK_USED; }

// PATCH ALL POINTERS
blksize+=6;

__sat3_fixptrs(obj+blksize,sat3_peek(SAT_TEMPTOP,5),-blksize);

// MOVE THE MEMORY BLOCK

sat3_memmove(obj,obj+blksize,(SAT_OBJECT)sat3_peek(SAT_RSKTOP,5)-(obj+blksize));

// PATCH LAST FEW POINTERS	
    // RSKTOP
    sat3_poke(SAT_RSKTOP,sat3_peek(SAT_RSKTOP,5)-blksize,5);
    
    // TEMPTOP
    sat3_poke(SAT_TEMPTOP,sat3_peek(SAT_TEMPTOP,5)-blksize,5);
    
    // ADJUST FREE MEMORY
    int freemem=sat3_peek(SAT_DSKTOP,5)-sat3_peek(SAT_RSKTOP,5);
    freemem/=5;
    sat3_poke(SAT_AVMEM,freemem,5);	
    
    return BLOCK_FREE;
}

